@echo off

rem FILE: makeall.bat           Copyright (c), Symmetric Research, 1998-2001
rem
rem This batch file does a complete build of the SR PAR24B software.  See
rem the makeall.rpt report file when done for any errors.  Note that you 
rem must have the Microsoft Visual C++ 6.0 compiler installed for this
rem file to run correctly.
rem
rem



echo Building SR PAR24B NT software ... see makeall.rpt for errors ...
echo.

echo SR PAR24B NT build report ...               > MAKEALL.RPT


cd driver
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\dll
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\diags
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\examples
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\meter
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\simple
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\scope
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\2task
nmake /a                                        >> ..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\convert\ascii
nmake /a                                        >> ..\..\MAKEALL.RPT
if errorlevel 1 goto error

cd ..\..\convert\suds
nmake /a                                        >> ..\..\MAKEALL.RPT
if errorlevel 1 goto error


goto return







rem Return to DOS:
rem
rem

:error

echo An error occurred, see the makeall.rpt report file ...

:return

cd ..\..

@echo on