VERSION 5.00
Begin VB.Form Demo 
   Caption         =   "PAR24B Demo"
   ClientHeight    =   4230
   ClientLeft      =   1125
   ClientTop       =   1410
   ClientWidth     =   5370
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4230
   ScaleWidth      =   5370
   Begin VB.TextBox InstructTxt 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0C0C0&
      Height          =   975
      Left            =   240
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "DEMO.frx":0000
      Top             =   120
      Width           =   4935
   End
   Begin VB.Frame PortModeFra 
      Caption         =   "Port Mode"
      Height          =   1695
      Left            =   360
      TabIndex        =   1
      Top             =   1320
      Width           =   1335
      Begin VB.OptionButton PortModeOpt 
         Caption         =   "ECP/EPP"
         Height          =   255
         Index           =   3
         Left            =   120
         TabIndex        =   5
         Top             =   1320
         Width           =   1095
      End
      Begin VB.OptionButton PortModeOpt 
         Caption         =   "ECP/BPP"
         Height          =   255
         Index           =   2
         Left            =   120
         TabIndex        =   4
         Top             =   960
         Width           =   1095
      End
      Begin VB.OptionButton PortModeOpt 
         Caption         =   "BPP"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   2
         Top             =   240
         Width           =   1095
      End
      Begin VB.OptionButton PortModeOpt 
         Caption         =   "EPP"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   3
         Top             =   600
         Value           =   -1  'True
         Width           =   1095
      End
   End
   Begin VB.ListBox PortAddrLst 
      Height          =   255
      ItemData        =   "DEMO.frx":0103
      Left            =   2400
      List            =   "DEMO.frx":0105
      TabIndex        =   7
      Top             =   1680
      Width           =   1815
   End
   Begin VB.TextBox FifoSizeTxt 
      Height          =   285
      Left            =   2040
      TabIndex        =   9
      Text            =   "None"
      Top             =   2760
      Width           =   975
   End
   Begin VB.TextBox FileNumTxt 
      Height          =   285
      Left            =   3720
      TabIndex        =   11
      Text            =   "None"
      Top             =   2760
      Width           =   975
   End
   Begin VB.CommandButton RunBtn 
      Caption         =   "Run"
      Height          =   615
      Left            =   720
      TabIndex        =   12
      Top             =   3360
      Width           =   1215
   End
   Begin VB.CommandButton StopBtn 
      Caption         =   "Stop"
      Height          =   615
      Left            =   2160
      TabIndex        =   13
      Top             =   3360
      Width           =   1215
   End
   Begin VB.CommandButton ExitBtn 
      Caption         =   "Exit"
      Height          =   615
      Left            =   3600
      TabIndex        =   14
      Top             =   3360
      Width           =   1215
   End
   Begin VB.Label PortAddrLbl 
      Caption         =   "Port Address"
      Height          =   255
      Left            =   2400
      TabIndex        =   6
      Top             =   1320
      Width           =   1815
   End
   Begin VB.Label FifoSizeLbl 
      Caption         =   "Found Fifo Size"
      Height          =   255
      Left            =   2040
      TabIndex        =   8
      Top             =   2400
      Width           =   1215
   End
   Begin VB.Label FileNumLbl 
      Caption         =   "Wrote File Number"
      Height          =   255
      Left            =   3600
      TabIndex        =   10
      Top             =   2400
      Width           =   1455
   End
End
Attribute VB_Name = "Demo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()

        ' Initialize port address list

        PortAddrLst.Clear

        PortAddrLst.AddItem "&H378"
        PortAddrLst.ItemData(PortAddrLst.NewIndex) = &H378

        PortAddrLst.AddItem "&H278"
        PortAddrLst.ItemData(PortAddrLst.NewIndex) = &H278
        
        PortAddrLst.Selected(0) = True

        

        ' Initialize other variables

        NL = Chr(13) & Chr(10)
        WorkingDir = App.Path


        ' Set initial state

        DemoState = DEMO_STOPPED
        FileNumLbl.Enabled = False
        FileNumTxt.Enabled = False
        FifoSizeLbl.Enabled = False
        FifoSizeTxt.Enabled = False

End Sub


Private Sub RunBtn_Click()

        Dim Ready          As Long
        Dim Nread          As Long
        Dim Init           As Long
        Dim HI7190_CrValue As Long
        Dim ErrorCode      As Long
        Dim MsgWords       As String
        Dim MsgResponse    As Integer
        

        ' Get port information from controls

        PortAddress = PortAddrLst.ItemData(PortAddrLst.ListIndex)
        
        If (PortModeOpt(0).Value = True) Then
                PortMode = PAR24B_PORT_MODE_BPP
        ElseIf (PortModeOpt(1).Value = True) Then
                PortMode = PAR24B_PORT_MODE_EPP
        ElseIf (PortModeOpt(2).Value = True) Then
                PortMode = PAR24B_PORT_MODE_ECP_BPP
        ElseIf (PortModeOpt(3).Value = True) Then
                PortMode = PAR24B_PORT_MODE_ECP_EPP
        Else
                PortMode = PAR24B_PORT_MODE_EPP
        End If



        ' Turn port controls off and fifo/file controls on

        PortAddrLbl.Enabled = False
        PortAddrLst.Enabled = False
        PortModeFra.Enabled = False
        PortModeOpt(0).Enabled = False
        PortModeOpt(1).Enabled = False
        PortModeOpt(2).Enabled = False
        PortModeOpt(3).Enabled = False

        FifoSizeLbl.Enabled = True
        FifoSizeTxt.Enabled = True
        FileNumLbl.Enabled = True
        FileNumTxt.Enabled = True

        FifoSizeTxt.Text = "None"
        FileNumTxt.Text = "None"
        FifoSizeTxt.Refresh
        FileNumTxt.Refresh

        FileNum = 0



        ' Open and initialize PAR24B
        
        Call PAR24B_Open

        Init = PAR24B_Init(PortAddress, PortMode, FifoSize, _
                           PAR24B_DC_OFFSET, PAR24B_FP_100Hz, _
                           PAR24B_GAIN_1, PAR24B_CAL_MODE_SELF, _
                           HI7190_CrValue, ErrorCode)

        If (Init = 0) Then
            MsgWords = "Could not initialize PAR24B board"
            MsgResponse = MsgBox(MsgWords, vbOKOnly, "ERR_INIT")
            Call PAR24B_Close
            Unload Me
            Exit Sub
        End If



        ' Display and validate FIFO size

        FifoSizeTxt.Text = Str(FifoSize)
        FifoSizeTxt.Refresh
        
        If (FifoSize > PAR24B_FIFO_SIZE_MAX) Then
            MsgWords = "FifoSize of " + Str(FifoSize) + " greater than max of "
            MsgWords = MsgWords + Str(PAR24B_FIFO_SIZE_MAX)
            MsgResponse = MsgBox(MsgWords, vbOKOnly, "ERR_FIFO")
            Call PAR24B_Close
            Unload Me
            Exit Sub
        End If



        ' Dimension data array to hold buffer 1/2 size of FIFO

        Call PAR24B_FifoSizeToNvalues(FifoSize, Nvalues)
        ReDim DataArray(0 To Nvalues)




        ' Begin acquisition

        DemoState = DEMO_RUNNING
        Call PAR24B_Start

        Do While (DemoState = DEMO_RUNNING)

                ' Check that a buffer of data is ready

                Ready = PAR24B_IsReady()

                If (Ready = 1) Then

                        ' Read the data

                        Nread = PAR24B_GetData(DataArray(0), Nvalues)

                        ' Write data to a file and disply file number

                        Call Write_Data
                        FileNumTxt.Text = Str(FileNum - 1)
                        FileNumTxt.Refresh
                End If

                ' Check to see if stop button has been pressed
                DoEvents

        Loop

End Sub

Private Sub StopBtn_Click()

        ' Stop and close PAR24B

        Call PAR24B_Stop
        DemoState = DEMO_STOPPED

        Call PAR24B_Close


        ' Turn port controls on and fifo/file controls off

        PortAddrLbl.Enabled = True
        PortAddrLst.Enabled = True
        PortModeFra.Enabled = True
        PortModeOpt(0).Enabled = True
        PortModeOpt(1).Enabled = True
        PortModeOpt(2).Enabled = True
        PortModeOpt(3).Enabled = True

        FifoSizeLbl.Enabled = False
        FifoSizeTxt.Enabled = False
        FileNumLbl.Enabled = False
        FileNumTxt.Enabled = False
        
End Sub

Private Sub ExitBtn_Click()

        ' Be sure to stop before exiting

        If (DemoState = DEMO_RUNNING) Then
                Call StopBtn_Click
        End If


        ' Do exit

        Unload Me
End Sub


