Attribute VB_Name = "modDemo"

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' FILE: demo.bas                     Copyright Symmetric Research 2001 '
'                                                                      '
' This file contains constants, global variables and general routines  '
' for the Visual Basic PAR24B test program.                            '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                      '
'                           CONSTANTS                                  '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Const DEMO_STOPPED As Long = 0
Public Const DEMO_RUNNING As Long = 1




''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                      '
'                      GLOBAL VARIABLES                                '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public PortAddress As Long
Public PortMode    As Long
Public FifoSize    As Long
Public Nvalues     As Long
Public FileNum     As Long
Public DemoState   As Long
Public DataArray() As Long
Public NL          As String
Public WorkingDir  As String



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'                                                                      '
'                      GLOBAL PROCEDURES                               '
'                                                                      '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Public Sub Write_Data()
        Dim FileId      As Integer
        Dim FileName    As String
        Dim MsgWords    As String
        Dim MsgResponse As Integer
        


        ' Set file name and id

        FileName = WorkingDir & "\" & Format(FileNum, "00000000") & ".out"
        FileId = FreeFile



        ' Open file

        Open FileName For Binary Access Write Shared As FileId

        If (Err.Number <> 0) Then
            MsgWords = "ERROR " & Err.Number & ": " & Err.Description
            MsgWords = MsgWords & NL & "Can't open file " & FileName
            MsgResponse = MsgBox(MsgWords, vbOKOnly, "ERR_FILE")
            Err.Clear
        End If



        ' Output data

        Put FileId, 1, DataArray

        If (Err.Number <> 0) Then
            MsgWords = "ERROR " & Err.Number & ": " & Err.Description
            MsgWords = MsgWords & NL & "Can't write to file " & FileName
            MsgResponse = MsgBox(MsgWords, vbOKOnly, "ERR_FILE")
            Err.Clear
        End If



        ' Close file and increment number

        Close FileId
        FileNum = FileNum + 1

End Sub
